module surcharge
  interface assignment(=)
    module procedure affect_int_bool
  end interface
  interface operator(==)
    module procedure compare_eq_bool
  end interface
  interface operator(/=)
    module procedure compare_ne_bool
  end interface
contains
  logical function compare_eq_bool(l1, l2)
    logical, intent(in) :: l1, l2

    compare_eq_bool = l1.EQV.l2
  end function compare_eq_bool

  logical function compare_ne_bool(l1, l2)
    logical, intent(in) :: l1, l2

    compare_ne_bool = l1.NEQV.l2
  end function compare_ne_bool

  subroutine affect_int_bool(i, l)
    integer, intent(inout) :: i
    logical, intent(in)    :: l

    i = MERGE(tsource=1, fsource=0, mask=l)
  end subroutine affect_int_bool
end module surcharge

program exo9
  use surcharge

  integer i, j
  logical b1, b2

  b1 = .true.; b2 = .false.
  i = b1; j = b2
  print *,"b1 =", b1, " i =", i
  print *,"b2 =", b2, " j =", j

  if ( b1 == b2 ) print *, "b1 == b2"
  if ( b1 /= b2 ) print *, "b1 /= b2"
end program exo9
