program ex05
  implicit none
  !
  ! On decide que les entiers n,m sont < 100
  !
  integer, parameter                   :: p = selected_int_kind(2)
  integer(kind=p)                      :: n,m
  integer                              :: i, j
  integer, dimension(:,:), allocatable :: mat
  character(len=6)                     :: fmt = "(  I6)"
  !
  ! Lecture des dimensions de la matrice 
  !
  print *,"Entrez le nombre de lignes :"
  read(*,*)n
  print *,"Entrez le nombre de colonnes :"
  read(*,*)m
  write( fmt(2:3), '(i2)' ) m
  !
  ! Une fois les dimensions connues, on peut allouer la matrice
  !
  allocate(mat(n,m))
  !
  ! Remplissage des lignes de rang pair avec l'entier 1
  !
  mat(2:n:2,:) = 1
  !
  ! Remplissage des lignes de rang impair avec les entiers 1,2,...
  ! Comme valeur du mot-cle shape de la fonction reshape, on doit
  ! obligatoirement indiquer un vecteur de taille constante, d'ou
  ! l'instruction suivante.
  !
  mat(1:n:2,:) = reshape(source=(/ (i,i=1,size(mat(1:n:2,:))) /), &
                         shape=shape( mat(1:n:2,:) ),             &
                         order=(/ 2,1 /))
  !
  ! On imprime la matrice obtenue apres remplissage
  !
  print fmt, ((mat(i,j),j=1,m),i=1,n)
  deallocate(mat)
end program ex05
