program exo9
  implicit none
  type ligne
    integer, dimension(:), allocatable :: p
  end type
  type(ligne), dimension(:), allocatable :: triangle
  integer i, n, etat

  do
    write(6, advance='no',fmt="('Entrez l''ordre du triangle : ')")
    read(5, *, iostat=etat)n
    ! On se limite  des triangles d'au plus
    ! 19 lignes  cause du format de sortie.
    if (etat /= 0 .OR. n >= 20) exit
    ! On alloue le nombre de lignes du triangle.
    allocate(triangle(n))
    do i=1,n
      ! Pour chaque ligne du triangle on alloue
      ! le nombre de colonnes.
      allocate(triangle(i)%p(i))
      !-Valorisation des lments extrmes de la ligne courante puis des
      !-lments intermdiaires au moyen d'une expression vectorielle.
      triangle(i)%p((/ 1,i /)) = 1
      !-Pour "i=2", les oprandes de l'expression suivante sont
      !-des tableaux de taille nulle : "zero-sized array"
      if (i>1) &
        triangle(i)%p(2:i-1) = triangle(i-1)%p(2:i-1) + &
                               triangle(i-1)%p(1:i-2)
      ! Puis on imprime la ligne obtenue.
      print "(*(i5,1x))",triangle(i)%p ! * : fortran 2008
    end do
    ! Libration du triangle. Les composantes "p" de
    ! chacun des lments du triangle seront libres
    ! automatiquement.
    deallocate(triangle)
  end do
end program exo9
