FC = ifort
current_dir = $(shell pwd)
FFLAGS = -I$(current_dir)/../lapack95
LIBS = -L$(current_dir)/../lapack95 -loper
LDFLAGS = -Bstatic -Wl,--start-group -lmkl_intel_lp64 -lmkl_sequential -lmkl_core -Wl,--end-group -Bdynamic
EXE = exo11.exe

.SUFFIXES:
.SUFFIXES: .f90 .o

.f90.o:
	$(FC) -c $(FFLAGS) $<

include .depend

depend .depend:
	makedepf90 \
          -l '$$(FC) $$(FFLAGS) $$(FOBJ) $$(LIBS) $$(LDFLAGS) -o $$@' \
          *.f90 -o $(EXE) > .depend

clean:
	rm -f *.o *.mod *.smod .depend core $(EXE)
