program exo4
  implicit none
  integer, parameter        :: nx=100, ny=200, nz=5
  real, dimension(nx,ny,nz) :: tab1, tab2
  real, dimension(nx)       :: vec1
  real, dimension(ny)       :: vec2
  integer i, j, k

  ! On valorise les vecteurs "vec1, vec2"  l'aide de nombres alatoires :
  call random_number(vec1)
  call random_number(vec2)

  ! Calculs scalaires
  DO k=1,nz
    DO j=1,ny
      DO i=1,nx
        tab1(i,j,k)= sqrt(vec1(i))*exp(vec2(j))
      ENDDO
    ENDDO
  ENDDO

  ! Rcriture des boucles prcdentes  l'aide d'une expression tableaux :
         ...
         ...

  block
    integer, parameter :: k = 3
    logical            :: flag

    flag = maxval(abs(tab1-tab2)) < minval(k*spacing(tab1))
    print *, MERGE(tsource="tab1 et tab2 sont identiques", &
                   fsource="tab1 et tab2 sont différents", &
                   mask=flag)
  end block

end program exo4
