MODULE F95_LAPACK
  
  INTERFACE LA_GEEV
    SUBROUTINE SGEEV_F95( A, WR, WI, VL, VR, INFO )
      USE LA_PRECISION, ONLY: WP => SP
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: WR(:), WI(:)
      REAL(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
    END SUBROUTINE SGEEV_F95
    
    SUBROUTINE DGEEV_F95( A, WR, WI, VL, VR, INFO )
      USE LA_PRECISION, ONLY: WP => DP
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: WR(:), WI(:)
      REAL(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
    END SUBROUTINE DGEEV_F95
    
  END INTERFACE
END MODULE F95_LAPACK
