program exo4
  implicit none
  integer, parameter        :: nx=100, ny=200, nz=5
  real, dimension(nx,ny,nz) :: tab1, tab2
  real, dimension(nx)       :: vec1
  real, dimension(ny)       :: vec2
  integer i, j, k

  call random_number(vec1)
  call random_number(vec2)

  ! Calculs scalaires
  DO k=1,nz
    DO j=1,ny
      DO i=1,nx
        tab1(i,j,k)= sqrt(vec1(i))*exp(vec2(j))
      ENDDO
    ENDDO
  ENDDO

  ! Calculs vectoriels
  tab2(:,:,:) = SPREAD(source=SPREAD(source=sqrt(vec1(:)),dim=2,ncopies=ny)* &
                              SPREAD(source= exp(vec2(:)),dim=1,ncopies=nx), &
                       dim=3,ncopies=nz)

  block
    integer, parameter :: k = 3
    logical            :: flag

    flag = MAXVAL(abs(tab1-tab2)) < MINVAL(k*spacing(tab1))
    print *, MERGE(tsource="tab1 et tab2 sont identiques", &
                   fsource="tab1 et tab2 sont differents", &
                   mask=flag)
  end block
end program exo4
