program exo6
  implicit none
  real,    dimension(:,:), allocatable :: A
  logical, dimension(:,:), allocatable :: m
  integer                              :: N, i, j
  character(len=8)                     :: fmt = "(  F5.0)"

  !------- Allocation/initialisation de A --------------
  print *, "N (multiple de 4 < 32) ?" ; read *, N
  allocate(A(N,N), m(N,N))
  write( fmt(2:3), '(i2)' ) N
  A = reshape(source=[ (real(i), i=1,N*N) ], shape=shape(A), order=[ 2,1 ])
  m = reshape(source=[ ((i==j,i=1,N),j=1,N) ], shape=shape(m))
  call imp( "Matrice  transformer :" )
  !------------- Transformation des lignes -------------
  do i=1,N,4
    A(:,i:N) = cshift(array=A(:,i:N), shift=-2, dim=2)
  end do 
  !------------- Transformation des colonnes -----------
  do i=1,N,4
    A(i:N,:) = cshift(array=A(i:N,:), shift=-2, dim=1)
  end do 
  call imp( "Matrice transforme :" )
  deallocate(A) ; deallocate(m)
  contains
    subroutine imp(titre)
      character(len=*) titre

      print "(/,A,/)", titre
      print fmt, ((A(i,j),j=1,N),i=1,N)
      print *, "trace = ", sum(pack(array=A, mask=m))
    end subroutine imp
end program exo6
