program exo7
  integer, parameter  :: long=80
  character(len=long) :: chaine
  integer             :: long_util, ios, choix
  logical             :: entree_valide

  do
    entree_valide = .true.
    print *, '1) Entre clavier'
    print *, '2) Lecture fichier "palindrome"'
    read( unit=*, fmt=*, iostat=ios ) choix
    if(ios > 0) entree_valide = .false.
    if(ios < 0) stop "Arrt demand"
    if(choix /= 1 .and. choix /= 2) entree_valide=.false.
    if(entree_valide ) exit
    print *, "Entre invalide"
  end do

  if ( choix == 2 ) open( unit=1, file="palindrome", &
                          form="formatted", action="read" )
  do
    select case( choix )
      case(1)
        print *, "Entrez une chane :"
        read( unit=*, fmt='(a)', iostat=ios ) chaine
      case(2)
        read( unit=1, fmt='(a)', iostat=ios ) chaine
    end select
    if( ios > 0 ) stop "Erreur de lecture"
    if( ios < 0 ) exit
    !
    ! Rcup. longueur chane entre (sans blancs de fin).
    !
    long_util = len_trim( chaine )

    if( palind( chaine(:long_util) ) ) then
      print *, chaine(:long_util)," est un palindrome"
    else
      print *, chaine(:long_util)," n'est pas un palindrome"
    endif
  enddo
  if ( choix == 2 ) close( unit=1 )
contains

  function palind( chaine )
    logical                 :: palind    !<-- Retour fonction
    character(len=*)        :: chaine    !<-- Arg. muet
    character(len=1), &
      dimension(len(chaine)):: tab_car   !<-- Tabl. automatique
    integer                 :: long_util !<-- Var. locale
    !
    ! Copie chane entre dans un tableau de caractres.
    !
    tab_car(:) = transfer( chaine, 'a', size(tab_car) )
    !
    ! Dans le cas o la chane contient une phrase,
    ! on supprime les blancs sparant les diffrents mots.
    !
    long_util = compression( tab_car(:) )
    !
    ! Comparaison des lments symtriques par rapport
    ! au milieu de la chane. La fonction "all" nous sert
    !  comparer le contenu de deux tableaux.
    !
    palind=all(tab_car(:long_util/2) == &
               tab_car(long_util:long_util-long_util/2+1:-1))
  end function palind

  function compression( tab_car ) result(long_util)
    integer              :: long_util !<-- Retour fonction
    character(len=1), &
      dimension(:)       :: tab_car   !<-- Profil implicite
    logical,          &
      dimension(size(tab_car)):: m    !<-- Tabl. automatique

    m(:) = tab_car(:) /= ' '
    long_util = count( mask=m(:) )
    tab_car(:long_util) = pack(array=tab_car(:), mask=m(:))
  end function compression

end program exo7
