module exo7_m
  implicit none
  integer :: choix
  
contains

  subroutine choix_fichier
    logical :: entree_valide
    integer :: ios

    do
      entree_valide = .true.
      print *, '1) Entre clavier'
      print *, '2) Lecture fichier "palindrome"'
      print *, ' Faire CtrD pour quitter'
      read( unit=*, fmt=*, iostat=ios ) choix
      if ( ios > 0 ) entree_valide = .false.
      if ( ios < 0 )    stop "Arrt demand"
      if ( choix /= 1 .and. choix /= 2 ) entree_valide=.false.
      if ( entree_valide ) exit
      print *, "Entre invalide"
    end do
  
    if ( choix == 2 ) open( unit=1, file="palindrome", &
                            form="formatted", action="read" )
  end subroutine choix_fichier

  subroutine traitement_fichier
    integer, parameter  :: long=80
    character(len=long) :: chaine
    integer             :: ios, long_util

    do
      select case( choix )
        case(1)
          print *, "Entrez une chane :"
          read( unit=*, fmt='(a)', iostat=ios ) chaine
        case(2)
          read( unit=1, fmt='(a)', iostat=ios ) chaine
      end select
      if( ios > 0 ) stop "Erreur de lecture"
      if( ios < 0 ) exit
      !
      ! Rcup. longueur chane entre (sans blancs de fin).
      !
      long_util = len_trim( chaine )
  
      if( palind( chaine(:long_util) ) ) then
        print *, chaine(:long_util)," est un palindrome"
      else
        print *, chaine(:long_util)," n'est pas un palindrome"
      endif
    enddo
    if ( choix == 2 ) close( unit=1 )
  end subroutine traitement_fichier

  function palind( chaine )
    ! Dclaration argument et retour de fonction
    logical                                     :: palind
    character(len=*)                            :: chaine
    ! Dclarations locales
    character(len=1), dimension(:), allocatable :: tab_car
    integer                                     :: long_util, i

    ! Copie chane entre dans un tableau de caractres.
    ! Norme 2003 : l'instruction qui suit alloue le tableau
    ! ----------   "tab_car" avec la taille ncessaire afin
    !              de respecter la conformance.
    tab_car = [ (chaine(i:i), i=1, len(chaine)) ]
    !
    ! Dans le cas o la chane contient une phrase,
    ! on supprime les blancs sparant les diffrents mots.
    !
    call compression( tab_car )
    !
    ! Comparaison des lments symtriques par rapport
    ! au milieu de la chane. La fonction "all" nous sert
    !  comparer le contenu de deux tableaux.
    !
    long_util = size( tab_car(:) )
    palind=all(tab_car(:long_util/2) == &
               tab_car(long_util:long_util-long_util/2+1:-1))

  contains

    subroutine compression( tab_car )
      character(len=1), dimension(:), allocatable :: tab_car ! norme 2003
      logical,          dimension(size(tab_car))  :: m    !<-- Tabl. automatique

      m(:) = tab_car(:) /= ' '
      ! Norme 2003 : l'instruction suivante ralloue de faon automatique
      ! ----------   le tableau "tab_car" afin de respecter la conformance.
      tab_car = pack(array=tab_car(:), mask=m(:))
    end subroutine compression
  end function palind
end module exo7_m

program exo7
  use exo7_m

  call choix_fichier
  call traitement_fichier

end program exo7
